//+----------------------------------------------------------------------------------+
//|                                                                     bigdogus.mq4 |
//|                                                                           mladen |
//+----------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1

//
//
//
//
//

extern string TargetTimeFrame      = "H1";
extern int    TargetTimeFrameBarNo = 2;
extern int    ExtendBars           = 10;
extern bool   UseOpenClose         = false;
extern string UniqueID             = "bigdogus";
extern color  ColorBox             = Gainsboro;
extern color  ColorUpperBorder     = DeepSkyBlue;
extern color  ColorLowerBorder     = PaleVioletRed;
extern int    BordersWidth         = 2;
extern int    alertsUsePrice       = PRICE_CLOSE;
extern bool   alertsOn             = false;
extern bool   alertsOnCurrent      = false;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsEmail          = false;

//
//
//
//
//

double price[];
int    timeFrame;

//+----------------------------------------------------------------------------------+
//|                                                                                  |
//+----------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,price); SetIndexStyle(0,DRAW_NONE);

      TargetTimeFrameBarNo = MathMax(TargetTimeFrameBarNo,1);
      timeFrame = stringToTimeFrame(TargetTimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" bigdogus indicator");

   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);

      for (int i = ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i); if (StringSubstr(name,0,lookForLength)==lookFor) ObjectDelete(name);
      }

   return (0);
}

//+----------------------------------------------------------------------------------+
//|                                                                                  |
//+----------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars  = IndicatorCounted();
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(MathMax(Bars-counted_bars,iBarShift(NULL,0,iTime(NULL,PERIOD_D1,0))),Bars-1);
           if (Period()>=PERIOD_D1) { Comment("Indicator should work on time frame less than daily"); return(0); }

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      price[i] = iMA(NULL,0,1,0,MODE_SMA,alertsUsePrice,i);
      if (iBarShift(NULL,PERIOD_D1,Time[i])==iBarShift(NULL,PERIOD_D1,Time[i+1])) continue;
      
      //
      //
      //
      //
      //
         
         datetime startTime = StrToTime(TimeToStr(Time[i],TIME_DATE));
         int      barShift  = iBarShift(NULL,timeFrame,startTime,true);
         int      barStart  = barShift-(TargetTimeFrameBarNo-1);

            if (barShift==-1) continue;
               
            double price1;
            double price2;
      
               if (UseOpenClose)
                  {
                     price1 = iClose(NULL,timeFrame,barStart);
                     price2 = iOpen(NULL,timeFrame,barStart);
                  }
               else
                  {
                     price1 = iHigh(NULL,timeFrame,barStart);
                     price2 = iLow(NULL,timeFrame,barStart);
                  }
         //
         //
         //
         //
         //
         
            double   high  = MathMax(price1,price2);                  
            double   low   = MathMin(price1,price2);                  
            datetime time1 = startTime+(TargetTimeFrameBarNo-1)           *timeFrame*60;
            datetime time2 = startTime+(TargetTimeFrameBarNo+ExtendBars-1)*timeFrame*60;
         
            //
            //
            //
            //
            //
            
            string name = UniqueID+":b"+startTime;
               if (ObjectFind(name)==-1) ObjectCreate(name,OBJ_RECTANGLE,0,0,0,0,0);
                    ObjectSet(name,OBJPROP_TIME1,time1);
                    ObjectSet(name,OBJPROP_TIME2,time2);
                    ObjectSet(name,OBJPROP_PRICE1,high);
                    ObjectSet(name,OBJPROP_PRICE2,low);
                    ObjectSet(name,OBJPROP_COLOR,ColorBox);
                    ObjectSet(name,OBJPROP_BACK,true);
            
            name = UniqueID+":u"+startTime;
               if (ObjectFind(name)==-1) ObjectCreate(name,OBJ_TREND,0,0,0,0,0);
                    ObjectSet(name,OBJPROP_TIME1,time1);
                    ObjectSet(name,OBJPROP_TIME2,time2);
                    ObjectSet(name,OBJPROP_PRICE1,high);
                    ObjectSet(name,OBJPROP_PRICE2,high);
                    ObjectSet(name,OBJPROP_COLOR,ColorUpperBorder);
                    ObjectSet(name,OBJPROP_RAY,false);
                    ObjectSet(name,OBJPROP_WIDTH,BordersWidth);

            name = UniqueID+":l"+startTime;
               if (ObjectFind(name)==-1) ObjectCreate(name,OBJ_TREND,0,0,0,0,0);
                    ObjectSet(name,OBJPROP_TIME1,time1);
                    ObjectSet(name,OBJPROP_TIME2,time2);
                    ObjectSet(name,OBJPROP_PRICE1,low);
                    ObjectSet(name,OBJPROP_PRICE2,low);
                    ObjectSet(name,OBJPROP_COLOR,ColorLowerBorder);
                    ObjectSet(name,OBJPROP_RAY,false);
                    ObjectSet(name,OBJPROP_WIDTH,BordersWidth);
   }
   
   //
   //
   //
   //
   //

   if (alertsOn)
   {   
      startTime = StrToTime(TimeToStr(Time[0],TIME_DATE));
         name   = UniqueID+":b"+startTime;
         price1 = ObjectGet(name,OBJPROP_PRICE1);
         price2 = ObjectGet(name,OBJPROP_PRICE2);
         time1  = ObjectGet(name,OBJPROP_TIME1);
         time2  = ObjectGet(name,OBJPROP_TIME2);
      
         //
         //
         //
         //
         //
      
         if (alertsOnCurrent)
               int whichBar  = 0;
         else      whichBar  = 1;             
         datetime  barTime   = Time[whichBar];

            //
            //
            //
            //
            //
            
            if (time1<=barTime && time2>=barTime)
               if (price[whichBar+1]<=price1 && price[whichBar+1]>=price2)
               {
                  if (price[whichBar]>price1) doAlert("up");
                  if (price[whichBar]<price2) doAlert("down");
               }
   }     
   return(0);
}

//+----------------------------------------------------------------------------------+
//|                                                                                  |
//+----------------------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}


//+----------------------------------------------------------------------------------+
//|                                                                                  |
//+----------------------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," bigdogus price broke - ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"bigdogus"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}